package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.GoodsRoleCommissionService;
import com.gxwebsoft.shop.entity.GoodsRoleCommission;
import com.gxwebsoft.shop.param.GoodsRoleCommissionParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 商品绑定角色的分润金额控制器
 *
 * @author 科技小王子
 * @since 2024-12-02 12:43:40
 */
@Api(tags = "商品绑定角色的分润金额管理")
@RestController
@RequestMapping("/api/shop/goods-role-commission")
public class GoodsRoleCommissionController extends BaseController {
    @Resource
    private GoodsRoleCommissionService goodsRoleCommissionService;

    @ApiOperation("分页查询商品绑定角色的分润金额")
    @GetMapping("/page")
    public ApiResult<PageResult<GoodsRoleCommission>> page(GoodsRoleCommissionParam param) {
        // 使用关联查询
        return success(goodsRoleCommissionService.pageRel(param));
    }

    @ApiOperation("查询全部商品绑定角色的分润金额")
    @GetMapping()
    public ApiResult<List<GoodsRoleCommission>> list(GoodsRoleCommissionParam param) {
        // 使用关联查询
        return success(goodsRoleCommissionService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:goodsRoleCommission:list')")
    @ApiOperation("根据id查询商品绑定角色的分润金额")
    @GetMapping("/{id}")
    public ApiResult<GoodsRoleCommission> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(goodsRoleCommissionService.getByIdRel(id));
    }

    @ApiOperation("添加商品绑定角色的分润金额")
    @PostMapping()
    public ApiResult<?> save(@RequestBody GoodsRoleCommission goodsRoleCommission) {

        if (goodsRoleCommissionService.save(goodsRoleCommission)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改商品绑定角色的分润金额")
    @PutMapping()
    public ApiResult<?> update(@RequestBody GoodsRoleCommission goodsRoleCommission) {
        if (goodsRoleCommissionService.updateById(goodsRoleCommission)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除商品绑定角色的分润金额")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (goodsRoleCommissionService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加商品绑定角色的分润金额")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<GoodsRoleCommission> list) {
        if (goodsRoleCommissionService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改商品绑定角色的分润金额")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<GoodsRoleCommission> batchParam) {
        if (batchParam.update(goodsRoleCommissionService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除商品绑定角色的分润金额")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (goodsRoleCommissionService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
